Colorize::Object(T) - Crystal 1.20.1

# struct Colorize::Object(T)

- Colorize::Object(T)
- Struct
- Value
- Object

##
Overview

A colorized object. Colors and text decorations can be modified.

##
Defined in:

colorize.cr

##
Constructors

- .new(object : T)

##
Instance Method Summary

- #ansi_escape(io : IO) : Nil

  Same as `#ansi_escape` but writes to a given io.

- #ansi_escape : String

  Prints the ANSI escape codes for an object.

- #back(r : UInt8, g : UInt8, b : UInt8)
- #back(color : Symbol) : self
- #back(back : Color) : self
- #back(back : UInt8)
- #black
- #blink

  Apply text decoration `Mode::Blink`.

- #blink_fast

  Apply text decoration `Mode::BlinkFast`.

- #blue
- #bold

  Apply text decoration `Mode::Bold`.

- #bright

  Apply text decoration `Mode::Bright`.

- #cyan
- #dark_gray
- #default
- #dim

  Apply text decoration `Mode::Dim`.

- #double_underline

  Apply text decoration `Mode::DoubleUnderline`.

- #fore(r : UInt8, g : UInt8, b : UInt8)
- #fore(color : Symbol) : self
- #fore(fore : Color) : self
- #fore(fore : UInt8)
- #green
- #hidden

  Apply text decoration `Mode::Hidden`.

- #inspect(io : IO) : Nil

  Inspects this object and makes the ANSI escape codes visible.

- #italic

  Apply text decoration `Mode::Italic`.

- #light_blue
- #light_cyan
- #light_gray
- #light_green
- #light_magenta
- #light_red
- #light_yellow
- #magenta
- #mode(mode : Mode) : self

  Adds mode to the text's decorations.

- #on(color : Symbol)
- #on_black
- #on_blue
- #on_cyan
- #on_dark_gray
- #on_default
- #on_green
- #on_light_blue
- #on_light_cyan
- #on_light_gray
- #on_light_green
- #on_light_magenta
- #on_light_red
- #on_light_yellow
- #on_magenta
- #on_red
- #on_white
- #on_yellow
- #overline

  Apply text decoration `Mode::Overline`.

- #red
- #reverse

  Apply text decoration `Mode::Reverse`.

- #strikethrough

  Apply text decoration `Mode::Strikethrough`.

- #surround(io = STDOUT, &)

  Surrounds io by the ANSI escape codes and lets you build colored strings:

- #to_s(io : IO) : Nil

  Appends this object colored and with text decoration to io.

- #toggle(flag)

  Enables or disables colors and text decoration on this object.

- #underline

  Apply text decoration `Mode::Underline`.

- #white
- #yellow

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(object : T) #

##
Instance Method Detail

def ansi_escape(io : IO) : Nil #

Same as `#ansi_escape` but writes to a given io.

def ansi_escape : String #

Prints the ANSI escape codes for an object. Note that this has no effect on a `Colorize::Object` with content, only the escape codes.

    require "colorize"

    Colorize.with.red.ansi_escape        # => "\e[31m"
    "hello world".green.bold.ansi_escape # => "\e[32;1m"

def back(r : UInt8, g : UInt8, b : UInt8) #
def back(color : Symbol) : self #
def back(back : Color) : self #
def back(back : UInt8) #
def black #
def blink #

Apply text decoration `Mode::Blink`.

def blink_fast #

Apply text decoration `Mode::BlinkFast`.

def blue #
def bold #

Apply text decoration `Mode::Bold`.

def bright #

Apply text decoration `Mode::Bright`.

def cyan #
def dark_gray #
def default #
def dim #

Apply text decoration `Mode::Dim`.

def double_underline #

Apply text decoration `Mode::DoubleUnderline`.

def fore(r : UInt8, g : UInt8, b : UInt8) #
def fore(color : Symbol) : self #
def fore(fore : Color) : self #
def fore(fore : UInt8) #
def green #
def hidden #

Apply text decoration `Mode::Hidden`.

def inspect(io : IO) : Nil #

Inspects this object and makes the ANSI escape codes visible.

def italic #

Apply text decoration `Mode::Italic`.

def light_blue #
def light_cyan #
def light_gray #
def light_green #
def light_magenta #
def light_red #
def light_yellow #
def magenta #
def mode(mode : Mode) : self #

Adds mode to the text's decorations.

def on(color : Symbol) #
def on_black #
def on_blue #
def on_cyan #
def on_dark_gray #
def on_default #
def on_green #
def on_light_blue #
def on_light_cyan #
def on_light_gray #
def on_light_green #
def on_light_magenta #
def on_light_red #
def on_light_yellow #
def on_magenta #
def on_red #
def on_white #
def on_yellow #
def overline #

Apply text decoration `Mode::Overline`.

def red #
def reverse #

Apply text decoration `Mode::Reverse`.

def strikethrough #

Apply text decoration `Mode::Strikethrough`.

def surround(io = STDOUT, &) #

Surrounds io by the ANSI escape codes and lets you build colored strings:

    require "colorize"

    io = IO::Memory.new

    Colorize.with.red.surround(io) do
      io << "colorful"
      Colorize.with.green.bold.surround(io) do
        io << " hello "
      end
      Colorize.with.blue.surround(io) do
        io << "world"
      end
      io << " string"
    end

    io.to_s # returns a colorful string where "colorful" is red, "hello" green, "world" blue and " string" red again

def to_s(io : IO) : Nil #

Appends this object colored and with text decoration to io.

def toggle(flag) #

Enables or disables colors and text decoration on this object.

def underline #

Apply text decoration `Mode::Underline`.

def white #
def yellow #